
///////////////////////////////////////////////////////////////////////////////

#include "DeviceResources.h"
#include "TiledResourceLeakRepoCase.inc"


using namespace std;

///////////////////////////////////////////////////////////////////////////////

int wmain(int argc, wchar_t* argv[])
{
    HWND                        g_hwnd             = MakeWindow();
    shared_ptr<DeviceResources> g_deviceResources  = make_shared<DeviceResources>();

    g_deviceResources->SetWindow( g_hwnd );

    auto device = g_deviceResources->GetD3DDevice();
    auto context = g_deviceResources->GetD3DDeviceContext();

    context->Flush();
    Sleep( 2000u );

    //#include "GpuMemLeakSnipping.inc"

    bool forceLeak = true;

    // -> Sysinternals ProcessExplorer: dedicated GPU MEM: 4.8 MB        ( GeForce RTX 2080Ti )
    // -> Sysinternals ProcessExplorer: dedicated GPU MEM: 3.6 MB        ( GeForce GTX Titan  )
    // -> Sysinternals ProcessExplorer: dedicated GPU MEM: 1.5 MB        ( Quadro  RTX 3000 - Notebook )
    
    TiledResourceLeakRepoCase( device, context, forceLeak );

    // -> Sysinternals ProcessExplorer: dedicated GPU MEM: 708.8 MB      ( GeForce RTX 2080Ti )
    // -> Sysinternals ProcessExplorer: dedicated GPU MEM: 387.6 MB      ( GeForce GTX Titan )
    // -> Sysinternals ProcessExplorer: dedicated GPU MEM: 7.5 MB        ( Quadro  RTX 3000 - Notebook  )

    context->Flush();
    


    Sleep( 2000u );
    //exit( 0 );



    //RunLoop( g_deviceResources );
    wcout << L"Program ran to completion." << endl;
    return 0;
}
